/*    Copyright (c)  2005 http://www.beridoxy.com
      Permission is granted to copy, distribute and/or modify this document
      under the terms of the GNU Free Documentation License, Version 1.2
      or any later version published by the Free Software Foundation;
      with no Invariant Sections, no Front-Cover Texts, and no Back-Cover
      Texts.  A copy of the license is avaible at
      http://www.gnu.org/licenses/licenses.htm


*/
#include <windows.h>
#include <stdio.h>


/*  Declare Windows procedure  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);
float ProcSpeedCalc();


/*  Make the class name into a global variable  */
char szClassName[ ] = "Underclock GUI - Home MADE";

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)

{
    HWND hwnd;               /* This is the handle for our window */
    MSG messages;            /* Here messages to the application are saved */
    WNDCLASSEX wincl;        /* Data structure for the windowclass */

    /* The Window structure */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = szClassName;
    wincl.lpfnWndProc = WindowProcedure;      /* This function is called by windows */
    wincl.style = CS_DBLCLKS;                 /* Catch double-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);


    /* Use default icon and mouse-pointer */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;                 /* No menu */
    wincl.cbClsExtra = 0;                      /* No extra bytes after the window class */
    wincl.cbWndExtra = 0;                      /* structure or the window instance */
    /* Use Windows's default color as the background of the window */
    wincl.hbrBackground = (HBRUSH) COLOR_BACKGROUND;

    /* Register the window class, and if it fails quit the program */
    if (!RegisterClassEx (&wincl))
        return 0;

    /* The class is registered, let's create the program*/
    hwnd = CreateWindowEx (
           0,                   /* Extended possibilites for variation */
           szClassName,         /* Classname */
           "Windows App",       /* Title Text */
           WS_OVERLAPPEDWINDOW, /* default window */
           CW_USEDEFAULT,       /* Windows decides the position */
           CW_USEDEFAULT,       /* where the window ends up on the screen */
           440,                 /* The programs width */
           145,                 /* and height in pixels */
           HWND_DESKTOP,        /* The window is a child-window to desktop */
           NULL,                /* No menu */
           hThisInstance,       /* Program Instance handler */
           NULL                 /* No Window Creation data */
           );

    /* Make the window visible on the screen */
    ShowWindow (hwnd, nFunsterStil);

    /* Run the message loop. It will run until GetMessage() returns 0 */
    while (GetMessage (&messages, NULL, 0, 0))
    {
        /* Translate virtual-key messages into character messages */
        TranslateMessage(&messages);
        /* Send message to WindowProcedure */
        DispatchMessage(&messages);
    }

    /* The program return-value is 0 - The value that PostQuitMessage() gave */
    return messages.wParam;
}


/*  This function is called by the Windows function DispatchMessage()  */

LRESULT CALLBACK WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
static HWND Btn1 = 0;
static HWND Btn2 = 0;
static HWND Btn3 = 0;
    switch (message)                  /* handle the messages */
    {
        case WM_CREATE:
              Btn1 = CreateWindowEx(0,"BUTTON","Underclock 5FID > 1.1V",WS_CHILD | WS_VISIBLE | BS_TEXT | BS_CENTER | 
              BS_PUSHBUTTON | BS_NOTIFY | WS_TABSTOP ,
              10, 10, 410 ,25, hwnd,NULL, ((LPCREATESTRUCT) lParam)->hInstance, NULL);


          /*    Btn2 = CreateWindowEx(0,"BUTTON","Frequence",WS_CHILD | WS_VISIBLE | BS_TEXT | BS_CENTER | 
              BS_PUSHBUTTON | BS_NOTIFY | WS_TABSTOP ,
              10, 45, 410 ,25, hwnd,NULL, ((LPCREATESTRUCT) lParam)->hInstance, NULL);                 
            */   
              Btn3 = CreateWindowEx(0,"BUTTON","Normal 1.4V > 11FID",WS_CHILD | WS_VISIBLE | BS_TEXT | BS_CENTER | 
              BS_PUSHBUTTON | BS_NOTIFY | WS_TABSTOP ,
              10, 75, 410 ,25, hwnd,NULL, ((LPCREATESTRUCT) lParam)->hInstance, NULL);   
                 
                 
              break;
                 
                 
        case WM_DESTROY:
            PostQuitMessage (0);       /* send a WM_QUIT to the message queue */
            break;
            
        case WM_COMMAND:
            
            if (HIWORD(wParam) == BN_CLICKED && (HWND) lParam == Btn1) {    
//               MessageBoxA(hwnd,"TEST","1",1);
               int retour;
               retour = system("\"CG-NVNF4.exe -file=1000.ini\"");
               DestroyWindow (hwnd);
            }


/*           if (HIWORD(wParam) == BN_CLICKED && (HWND) lParam == Btn2) {    
               char str[1024];
               float hertz = ProcSpeedCalc();
               
               sprintf(str,"%f",&hertz);
               MessageBoxA(hwnd,"TEST",str,1);
           }
*/


            if (HIWORD(wParam) == BN_CLICKED && (HWND) lParam == Btn3) {    
               int retour;
               retour = system("\"CG-NVNF4.exe -file=2200.ini\"");
               DestroyWindow (hwnd);
            }

            

            return 0;
            
            break;
        default:                      /* for messages that we don't deal with */
            return DefWindowProc (hwnd, message, wParam, lParam);
    }

    return 0;
}

/*

float ProcSpeedCalc() {
/*
RdTSC:
It's the Pentium instruction "ReaD Time Stamp Counter". It measures the
number of clock cycles that have passed since the processor was reset, as a
64-bit number. That's what the <CODE>_emit lines do.*/
/*#define RdTSC __asm _emit 0x0f __asm _emit 0x31

// variables for the clock-cycles:
__int64 cyclesStart = 0, cyclesStop = 0;
// variables for the High-Res Preformance Counter:
unsigned __int64 nCtr = 0, nFreq = 0, nCtrStop = 0;


    // retrieve performance-counter frequency per second:
    if(!QueryPerformanceFrequency((LARGE_INTEGER *) &nFreq)) return 0;

    // retrieve the current value of the performance counter:
    QueryPerformanceCounter((LARGE_INTEGER *) &nCtrStop);

    // add the frequency to the counter-value:
    nCtrStop += nFreq;


    _asm
        {// retrieve the clock-cycles for the start value:
            RdTSC
            mov DWORD PTR cyclesStart, eax
            mov DWORD PTR [cyclesStart + 4], edx
        }

        do{
        // retrieve the value of the performance counter
        // until 1 sec has gone by:
             QueryPerformanceCounter((LARGE_INTEGER *) &nCtr);
          }while (nCtr < nCtrStop);

    _asm
        {// retrieve again the clock-cycles after 1 sec. has gone by:
            RdTSC
            mov DWORD PTR cyclesStop, eax
            mov DWORD PTR [cyclesStop + 4], edx
        }

// stop-start is speed in Hz divided by 1,000,000 is speed in MHz
return    ((float)cyclesStop-(float)cyclesStart) / 1000000;
}
*/
